HDU 3649 New Game

2023-10-30 13:20
文章标签 hdu new game 3649

本文主要是介绍HDU 3649 New Game,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

New Game


Problem Description
While ZSTU’s acmers were coding, coach Yehr was so bored that he created a new game to kill time. And the game is called “Yehr Game” because of the inventer.
Yehr Game is a board game involving two players. It is played on a board with 40 squares arranged in an ten-by-four grid. At the beginning of the game each player controls four pieces: one acm, one bahamas, one cab and one daze. If one player has no pieces to move, he lost the game.
Setup:
Yehr Game is played on a rectangle board of ten rows and four columns. The pieces are divided, by convention, into red and black sets. The players are referred to as "Red" and "Black", and each begins the game with four pieces of the specified color. These consist of one acm, one bahamas, one cab and one daze.



Movement:
First, they setup their pieces on the board.
(1) the piece red acm can be placed on A1~,A2,A3,A4,A5;the piece black acm A6~A10;
(2) the piece red bahamas can place on B1~B5; the piece black Bahamas B6~B10;
(3) the piece red cab can place on C1~C5; the piece black cab C6~C10;
(4) the piece red daze cab can place on D1~D5; the piece black daze D6~D10;
Second, they determine who moves first by dice. After the initial move, the players alternately move one piece at a time.
Each chess piece has its own style of moving.
(1) Acm can only move one direction: red from left to right; black from right to left. Acm can only move to the next square. If one player’s acm moves to a square with the opponent acm, he win the game.
(2) Bahamas and cab can move two direction: from left to right or from right to left. And they can move any number of squares but may not leap over other pieces.
(3) Daze can only move one direction: red from right to left; black from left to right.Daze can only move to the next square. In order to win the game, every clever player places the red daze on d5 and the black on d6.
Of Course, we assume that all players are clever.

Input
The input contains several test cases.
Each test case contains three lines:
First line contains one integer number 0 or 1: 0 indicated red move first and 1 black first.
Second line contains four integer numbers r1, r2, r3, r4 indicating the four red pieces’ square. For example, r3=3 indicating the red cab on C3.
Third line contains four integer numbers k1, k2, k3, k4 indicating the four black pieces’ square. For example, k1=9 indicating the black acm on A9.
We assume that r4 is always 5, and K4 is 6.


Output
For each test case, if red win print Red in a single line, else print Black.

Sample Input
  
0 4 5 5 5 7 6 6 6

Sample Output
  
Red


题目大意:

首先告诉你0或1,0表示红色先手,1表示黑色先手,接下来四个数字表示 红方 A,B,C,D四个子的位置,在接下来四个数字表示黑方 A,B,C,D四个子的位置。

游戏规则如下:

(1) the piece red acm can be placed on A1~,A2,A3,A4,A5;the piece black acm A6~A10;
(2) the piece red bahamas can place on B1~B5; the piece black Bahamas B6~B10;
(3) the piece red cab can place on C1~C5; the piece black cab C6~C10;
(4) the piece red daze cab can place on D1~D5; the piece black daze D6~D10;

解题思路:点击打开链接

SG函数

记a=k1-r1    b=k2-r2-1   c=k3-r3-1则

D:r4和k4不属于SG游戏,因为在D这个游戏里,两个玩家是互相独立的。所以r4和k4代表各自的机会,通俗的说就是我们玩魂斗罗时候的“命”

B,C:这两个游戏的SG函数都是b,c 即一个nim子游戏。

A:此游戏的SG函数值为a%2

证明D:当A,B,C游戏已经决定败局时,先手可以在D中进行一次操作(称“缓冲”),
             即ABC的败局扭转给后手。显然后手也只能在D中操作挽回败局。故谁在D
             中的缓冲区大谁就必胜。通俗的说就是局势以定的时候玩家拼命,谁命多,
             谁就胜了。

证明A:当A中两个棋子重合时后手败(被吃子)a=0 sg(A)=0
            否则,a的状态只能到达a-1所以sg(A)=a%2

证明B:显然b=0时必败,sg(B)=0。当然此时先手可以增加b的值来苟延残喘,但后
             手下一步操作只要再把b减到0,一直下去,先手不能再增加时,还是败了。
             然而b>0时的状态不好说,如果我们只考虑b只能减小,那不就成了nim子游
             戏了吗。事实上b的增大操作我们称为无效操作,因为处于优势的玩家可以
             不靠增加b来取状态,处于劣势的玩家即使增加了b,下一玩家再取回来就可
             以了。所以B与NIM子游戏等价。

证明C:同B


解题代码:

#include <iostream>
#include <cstdio>
using namespace std;int red[10],black[10],first;int solve(){if(black[1]-red[1]==1) return first;if(red[4]-1>10-black[4]) return 0;if(red[4]-1<10-black[4]) return 1;int sg=0;sg^=(black[2]-red[2]-1);sg^=(black[3]-red[3]-1);sg^=(black[1]-red[1])%2;if(sg) return first;else return first^1;
}int main(){while(scanf("%d",&first)!=EOF){for(int i=1;i<=4;i++) scanf("%d",&red[i]);for(int i=1;i<=4;i++) scanf("%d",&black[i]);if ( !solve() ) printf("Red\n");else printf("Black\n");}return 0;
}


这篇关于HDU 3649 New Game的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/308199

相关文章

Golan中 new() 、 make() 和简短声明符的区别和使用

《Golan中new()、make()和简短声明符的区别和使用》Go语言中的new()、make()和简短声明符的区别和使用,new()用于分配内存并返回指针,make()用于初始化切片、映射... 详细介绍golang的new() 、 make() 和简短声明符的区别和使用。文章目录 `new()`

usaco 1.3 Mixing Milk (结构体排序 qsort) and hdu 2020(sort)

到了这题学会了结构体排序 于是回去修改了 1.2 milking cows 的算法~ 结构体排序核心: 1.结构体定义 struct Milk{int price;int milks;}milk[5000]; 2.自定义的比较函数,若返回值为正,qsort 函数判定a>b ;为负,a<b;为0,a==b; int milkcmp(const void *va,c

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

hdu 3790 (单源最短路dijkstra)

题意: 每条边都有长度d 和花费p,给你起点s 终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。 解析: 考察对dijkstra的理解。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstrin

hdu 2489 (dfs枚举 + prim)

题意: 对于一棵顶点和边都有权值的树,使用下面的等式来计算Ratio 给定一个n 个顶点的完全图及它所有顶点和边的权值,找到一个该图含有m 个顶点的子图,并且让这个子图的Ratio 值在所有m 个顶点的树中最小。 解析: 因为数据量不大,先用dfs枚举搭配出m个子节点,算出点和,然后套个prim算出边和,每次比较大小即可。 dfs没有写好,A的老泪纵横。 错在把index在d

hdu 1102 uva 10397(最小生成树prim)

hdu 1102: 题意: 给一个邻接矩阵,给一些村庄间已经修的路,问最小生成树。 解析: 把已经修的路的权值改为0,套个prim()。 注意prim 最外层循坏为n-1。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstri